﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Globalization;
using System.IO;
using System.Linq;
using System.Management.Automation;
using System.Text;
using System.Text.RegularExpressions;
using System.Threading;
using System.Windows.Forms;
using System.Xml;
using OfficeOpenXml;

namespace DictionaryItemBaseUpdate
{
    public partial class Form1 : Form
    {
        private static Encoding encoding = new UTF8Encoding(true);
        public Form1()
        {
            InitializeComponent();
            label3.Visible = label5.Visible = label7.Visible = label9.Visible =
                textBox2.Visible = textBox3.Visible = textBox7.Visible = richTextBox1.Visible = false;
            label2.Visible = textBox4.Visible = false;
        }
        private void button1_Click(object sender, EventArgs e)
        {
            string innserExcMsg = string.Empty;
            richTextBox1.Visible = false;
            richTextBox1.BackColor = System.Drawing.Color.White;
            string lBase = GetBaseDirectory();
            label3.Visible = label5.Visible = label7.Visible = label9.Visible =
                textBox2.Visible = textBox3.Visible = textBox7.Visible = richTextBox1.Visible = false;
            if (string.IsNullOrWhiteSpace(textBox5.Text))
            {
                label7.Text = "Task száma kötelező!!!";
                label7.Visible = true;
            }
            else
            {
                DialogResult result = openFileDialog1.ShowDialog(); // Show the dialog.

                if (result == DialogResult.OK)
                {
                    if (openFileDialog1.CheckFileExists)
                    {
                        try
                        {
                            hasInsert = false;
                            hasUpdate = false;
                            //excel file feldolgozasa
                            List<DictionaryItemBase> lDictionaryItemBaseList = GetDictionaryItemsFromExcel(lBase);
                            hasInsert = lDictionaryItemBaseList.Count(x => !x.ID.HasValue) > 0;
                            hasUpdate = lDictionaryItemBaseList.Count(x => x.ID.HasValue) > 0;
                            if (hasUpdate && string.IsNullOrWhiteSpace(textBox6.Text))
                            {
                                innserExcMsg = label7.Text = "Update esetén tanév neve kötelező!!!";
                                label7.Visible = true;
                                throw new Exception();
                            }
                            //GeneratedDictionaryItems.kres file modositasa-bovitese
                            string lTanevNev = textBox6.Text;
                            string curDateTime = string.Empty;
                            string migrationUID = GetMigrationUID(out curDateTime);
                            string lInsertScripts = string.Empty;
                            string lUpdateScripts = ModifyKresFiles(lDictionaryItemBaseList, lBase, lTanevNev, ref lInsertScripts);

                            if (CodeGenerationCommandRunner(lBase))
                            {
                                innserExcMsg = "CodeGeneration hibára fut!!!";
                                label7.Visible = true;
                                throw new Exception();
                            }

                            string lTaskNumber = textBox5.Text.Replace('-', '_');
                            string ScriptsmigrationUID_Directory = lBase + "Kreta.DataAccess.Migrations\\Scripts\\" + migrationUID;
                            string uspCreateDictionaryItems_SQL = lBase + "\\Kreta.DataAccess.Migrations\\DBScripts\\Database\\dev\\uspCreateDictionaryItems.sql";
                            string Migration_uspCreateDictionaryItems_SQL = lBase + "Kreta.DataAccess.Migrations\\Scripts\\" + migrationUID + "\\uspCreateDictionaryItems.sql";
                            string MigrationsUID_CS = lBase + "Kreta.DataAccess.Migrations\\Migrations\\" + migrationUID + ".cs";
                            string UpdateScripts_SQL = lBase + "Kreta.DataAccess.Migrations\\Scripts\\" + migrationUID + "\\" + lTaskNumber + "_UpdateScripts.sql";
                            string InsertScripts_SQL = lBase + "Kreta.DataAccess.Migrations\\Scripts\\" + migrationUID + "\\" + lTaskNumber + "_InsertScripts.sql";

                            string KK_Enviroment_SQL = lBase + "Kreta.DataAccess.Migrations\\Scripts\\" + migrationUID + "\\" + lTaskNumber + "_KK_Enviroment_SQL.sql";
                            string NSZFH_Enviroment_SQL = lBase + "Kreta.DataAccess.Migrations\\Scripts\\" + migrationUID + "\\" + lTaskNumber + "_NSZFH_Enviroment_SQL.sql";
                            string AZURE_Enviroment_SQL = lBase + "Kreta.DataAccess.Migrations\\Scripts\\" + migrationUID + "\\" + lTaskNumber + "_AZURE_Enviroment_SQL.sql";
                            string HOI_Enviroment_SQL = lBase + "Kreta.DataAccess.Migrations\\Scripts\\" + migrationUID + "\\" + lTaskNumber + "_HOI_Enviroment_SQL.sql";

                            string DictionaryItemBaseUpdateMigration_Minta = lBase + "Kreta.DataAccess.Migrations\\DictionaryItemBaseUpdateMigration_Minta.txt";
                            if (!Directory.Exists(ScriptsmigrationUID_Directory))
                            {
                                DirectoryInfo di = Directory.CreateDirectory(ScriptsmigrationUID_Directory);
                            }

                            File.WriteAllText(MigrationsUID_CS, Regex.Replace(GetMigtrationFileContent(curDateTime, lTaskNumber, DictionaryItemBaseUpdateMigration_Minta, !string.IsNullOrWhiteSpace(lInsertScripts) && hasInsert, hasUpdate), "((?<!\r)\n|\r(?!\n))", "\r\n"));//Migration file
                            File.Copy(uspCreateDictionaryItems_SQL, Migration_uspCreateDictionaryItems_SQL, true);//uspCreateDictionaryItems

                            if (!string.IsNullOrWhiteSpace(lInsertScripts) && hasInsert)//InsertScripts
                            {
                                File.WriteAllText(InsertScripts_SQL, Regex.Replace(lInsertScripts, "((?<!\r)\n|\r(?!\n))", "\r\n"), encoding);
                            }

                            if (hasUpdate)
                            {
                                File.WriteAllText(UpdateScripts_SQL, Regex.Replace(lUpdateScripts, "((?<!\r)\n|\r(?!\n))", "\r\n"), encoding);//UpdateScripts
                            }

                            richTextBox1.Visible = true;
                            richTextBox1.Text = "Sikeres a migráció generálása !!!!!";
                            richTextBox1.BackColor = System.Drawing.Color.Green;
                        }
                        catch (Exception ex)
                        {
                            richTextBox1.Visible = true;
                            richTextBox1.Text = string.IsNullOrEmpty(innserExcMsg) ? ex.Message : innserExcMsg;
                            richTextBox1.BackColor = System.Drawing.Color.Red;
                        }
                    }
                }
            }
        }

        private string GetMigrationUID(out string curDateTime)
        {
            DateTime curDate = DateTime.Now;
            curDateTime = curDate.ToString("yyyyMMddHHmmss");
            return curDateTime + "_" + textBox5.Text.Replace('-', '_');
        }

        private List<DictionaryItemBase> GetDictionaryItemsFromExcel(string pBase)
        {
            string filepath = pBase + "Tools\\DictionaryItemBaseUpdate\\temporaryDictionaryExcel.xlsx";

            File.Copy(openFileDialog1.FileName, filepath, true);
            FileStream stream = File.OpenRead(filepath);
            var excelPackage = new ExcelPackage(stream);
            ExcelWorksheet workSheet = excelPackage.Workbook.Worksheets[1]; //NOTE: A worksheet-eket 1-től sorszámozza az epplus
            List<DictionaryItemBase> lDictionaryItemBaseList = GetDataFromExcel(workSheet);
            stream.Close();
            File.Delete(filepath);
            return lDictionaryItemBaseList;
        }

        private static string GetBaseDirectory()
        {
            string lBase = string.Empty;
            string[] baseDirectoryArray = AppDomain.CurrentDomain.BaseDirectory.Split('\\');
            for (int i = 0; i < baseDirectoryArray.Length; i++)
            {
                if (baseDirectoryArray[i] != "Tools")
                {
                    lBase += baseDirectoryArray[i] + "\\";
                }
                else
                {
                    break;
                }
            }

            return lBase;
        }

        private bool CodeGenerationCommandRunner(string lBase)
        {
            PowerShell ps = PowerShell.Create();
            ps.AddScript(lBase + @"Tools\CodeGeneration\Runner.ps1").Invoke();
            return ps.Streams.Error.Count > 0;

        }

        private void SetControlsAndMsg(string notExistIds, string NewDictionaryIds)
        {
            if (!string.IsNullOrWhiteSpace(notExistIds))
            {
                label5.Visible = true;
                textBox2.Visible = true;
                textBox2.Text = notExistIds;
            }

            if (!string.IsNullOrWhiteSpace(NewDictionaryIds))
            {
                label3.Visible = true;
                textBox3.Visible = true;
                textBox3.Text = NewDictionaryIds;
            }

        }
        private void GetMaxIDs(ref List<DictionaryItemBase> pDictionaryItemBaseList,
            XmlDocument pGeneratedDictionaryItemsKresFile, ref int pMaxDictionaryItemID)
        {
            int tmpDictionaryItemID = int.MinValue;
            int tmpDictionaryTypeID = int.MinValue;
            string tmpDictionaryTypeCode = string.Empty;
            //GetDictionaryTypeValues
            foreach (XmlNode iDictionaryTypeNode in pGeneratedDictionaryItemsKresFile.DocumentElement.SelectNodes("Dictionary"))
            {
                if (iDictionaryTypeNode.SelectNodes("Item[@Id='" + "7685" + "']").Count > 0)
                {
                    var akarmi = iDictionaryTypeNode;
                }
                Int32.TryParse(iDictionaryTypeNode.Attributes["Id"].Value.ToString(), out tmpDictionaryTypeID);
                tmpDictionaryTypeCode = iDictionaryTypeNode.Attributes["Code"].Value.ToString();

                if (tmpDictionaryTypeID > 0 && !string.IsNullOrWhiteSpace(tmpDictionaryTypeCode))
                {
                    foreach (var idictionaryItemBase in pDictionaryItemBaseList)
                    {
                        if ((!idictionaryItemBase.ID.HasValue && idictionaryItemBase.Values.Exists(x => x.DictionaryType == tmpDictionaryTypeCode)) || //UjDictionary es valamelyik kornyezetre be van allitva a type
                            (idictionaryItemBase.ID.HasValue && iDictionaryTypeNode.SelectNodes("Item[@Id='" + idictionaryItemBase.ID.Value.ToString() + "']").Count > 0)) //Nem uj de megegyezik a dictionarytype
                        {
                            foreach (var idictionaryItemBaseValue in idictionaryItemBase.Values)
                            {
                                idictionaryItemBaseValue.DictionaryType = tmpDictionaryTypeCode;
                                idictionaryItemBaseValue.DictionaryTypeId = tmpDictionaryTypeID;
                            }
                        }
                    }
                }
            }
            //GetMaxDictionaryId
            foreach (XmlNode iDictionaryItemNode in pGeneratedDictionaryItemsKresFile.DocumentElement.SelectNodes("Dictionary/Item"))
            {
                Int32.TryParse(iDictionaryItemNode.Attributes["Id"].Value.ToString(), out tmpDictionaryItemID);
                if (tmpDictionaryItemID > 0 && tmpDictionaryItemID > pMaxDictionaryItemID)
                {
                    pMaxDictionaryItemID = tmpDictionaryItemID;
                }
            }

            if (!string.IsNullOrWhiteSpace(textBox1.Text))
            {
                int tmpMaxDictionaryItemIDInput = int.MinValue;
                Int32.TryParse(textBox1.Text, out tmpMaxDictionaryItemIDInput);
                if (tmpMaxDictionaryItemIDInput > pMaxDictionaryItemID)
                    pMaxDictionaryItemID = tmpMaxDictionaryItemIDInput;
            }
        }

        private string ModifyKresFiles(List<DictionaryItemBase> pDictionaryItemBaseList, string pBase, string pTanevNev, ref string dictionaryItemInsertScripts)
        {
            bool hasInsert = pDictionaryItemBaseList.Count(x => !x.ID.HasValue) > 0;
            bool hasUpdate = pDictionaryItemBaseList.Count(x => x.ID.HasValue) > 0;
            string GeneratedDictionaryItems_KRES = pBase + "\\GeneratedDictionaryItems.kres";
            string lDictionaryItemUpdateScripts = Environment.NewLine +
                "DROP TABLE IF EXISTS tmpForSwitchDictionaryItemBase " + Environment.NewLine +
                "CREATE TABLE tmpForSwitchDictionaryItemBase(RegiID int, UjID int, TanevID int, C_NAME nvarchar(500), C_TYPE nvarchar(64), Torolni char(1))" + Environment.NewLine +
                "DECLARE @TEMP_EnvironmentName nvarchar(1000), @TanevSorszam int, @LastTanevSorszam int" + Environment.NewLine +
                "SET @LastTanevSorszam  = (SELECT MAX(C_SORSZAM) FROM T_TANEV WHERE TOROLT = 'F' AND (C_KOVETKEZO = 'T' OR C_AKTIV = 'T'))" + Environment.NewLine +
                "SET @TanevSorszam = ISNULL((SELECT TOP 1 C_SORSZAM FROM T_TANEV WHERE C_NEV = '" + (string.IsNullOrWhiteSpace(pTanevNev) ? "2000/2001" : pTanevNev) + "' ORDER BY C_SORSZAM),32)" + Environment.NewLine +
                "SET @TEMP_EnvironmentName = (SELECT [Value] " + Environment.NewLine +
                "FROM dev.EnvironmentInfo WHERE [Key] = 'Dictionary')" + Environment.NewLine +
                "IF (@TEMP_EnvironmentName IS NULL OR @TEMP_EnvironmentName NOT IN ('KK','NSZFH','HOI','AZURE'))" + Environment.NewLine +
                "BEGIN  INSERT INTO T_DICTIONARYITEMBASE(C_VALUE) VALUES('Nincs Dictionary ertek a dev.EnvironmentInfo tablaban') END  -- elszall a migracio ha nincs " + Environment.NewLine;
            string lDictionaryItemInsertScripts = Environment.NewLine +
                "DROP TABLE IF EXISTS tmpForSwitchDictionaryItemBase " + Environment.NewLine +
                "CREATE TABLE tmpForSwitchDictionaryItemBase(RegiID int, UjID int, TanevID int, C_NAME nvarchar(500), C_TYPE nvarchar(64), Torolni char(1))" + Environment.NewLine +
                "DECLARE @TEMP_EnvironmentName nvarchar(1000), @LastTanevSorszam int " + Environment.NewLine +
                "SET @LastTanevSorszam  = (SELECT MAX(C_SORSZAM) FROM T_TANEV WHERE TOROLT = 'F' AND (C_KOVETKEZO = 'T' OR C_AKTIV = 'T'))" + Environment.NewLine +
                "SET @TEMP_EnvironmentName = (SELECT [Value] " + Environment.NewLine +
                "FROM dev.EnvironmentInfo WHERE [Key] = 'Dictionary')" + Environment.NewLine +
                "IF (@TEMP_EnvironmentName IS NULL OR @TEMP_EnvironmentName NOT IN ('KK','NSZFH','HOI','AZURE'))" + Environment.NewLine +
                "BEGIN  INSERT INTO T_DICTIONARYITEMBASE(C_VALUE) VALUES('Nincs Dictionary ertek a dev.EnvironmentInfo tablaban') END  -- elszall a migracio ha nincs " + Environment.NewLine;
            string DictionaryUtoScriptekLista_Xlsx = pBase + "Tools\\DictionaryItemBaseUpdate\\DictionaryUtoScriptekLista.xlsx";
            FileStream stream = File.OpenRead(DictionaryUtoScriptekLista_Xlsx);
            var excelPackage = new ExcelPackage(stream);
            ExcelWorksheet workSheet = excelPackage.Workbook.Worksheets[1]; //NOTE: A worksheet-eket 1-től sorszámozza az epplus
            List<SpecOszlop> specOszlopList = new List<SpecOszlop>();
            List<SpecTabla> specTablaList = new List<SpecTabla>();
            List<SpecKomment> specKommentList = new List<SpecKomment>();

            string specOszlopScriptjei = string.Empty;
            string specTablakScriptjei = string.Empty;

            if (hasInsert || hasUpdate)
            {
                GetSpecTipusScriptsFromExcel(excelPackage.Workbook.Worksheets, out specOszlopList, out specTablaList, out specKommentList);
                if (specOszlopList.Any(x => pDictionaryItemBaseList.Any(y => y.Values.Any(z => z.DictionaryType.ToLower() == x.Tipus.ToLower()))) && specKommentList.Any(x => x.Tipus.ToLower() == "specoszlop"))
                {
                    specOszlopScriptjei += specKommentList.First(x => x.Tipus.ToLower() == "specoszlop").Szoveg + Environment.NewLine + Environment.NewLine;
                }
                if (specTablaList.Any(x => pDictionaryItemBaseList.Any(y => y.Values.Any(z => z.DictionaryType.ToLower() == x.Tipus.ToLower()))) && specKommentList.Any(x => x.Tipus.ToLower() == "spectabla"))
                {
                    specTablakScriptjei += specKommentList.First(x => x.Tipus.ToLower() == "spectabla").Szoveg + Environment.NewLine + Environment.NewLine;
                }
            }


            string notExistIds = string.Empty;
            string NewDictionaryIds = string.Empty;

            int lMaxDictionaryItemID = int.MinValue;

            // Load Kres files
            XmlDocument lGeneratedDictionaryItemsKresFile = new XmlDocument();
            lGeneratedDictionaryItemsKresFile.Load(GeneratedDictionaryItems_KRES);

            GetMaxIDs(ref pDictionaryItemBaseList, lGeneratedDictionaryItemsKresFile, ref lMaxDictionaryItemID);
            foreach (DictionaryItemBase iDictionaryItemBase in pDictionaryItemBaseList)
            {
                bool isUpdateDictionaryItemBase = iDictionaryItemBase.ID.HasValue;

                if (isUpdateDictionaryItemBase)
                {
                    XmlNode currentDictionaryItemNode = lGeneratedDictionaryItemsKresFile.DocumentElement.SelectSingleNode("Dictionary/Item[@Id='" + iDictionaryItemBase.ID.ToString() + "']");
                    if (currentDictionaryItemNode != null)
                    {
                        foreach (DictionaryItemBaseValue iDictionaryItemBaseValue in iDictionaryItemBase.Values.OrderBy(x => x.ItemValueOrder))/*Orderelni kell mivel a Defaulttal kell kezdeni, vegen updateAll ha esedekes*/
                        {
                            XmlNode currentEnvironmentDictionaryItemValueNode = currentDictionaryItemNode.SelectSingleNode("Value[@Environment='" + iDictionaryItemBaseValue.EnvironmentName + "']");
                            bool lCurEnvironmentExists = currentEnvironmentDictionaryItemValueNode != null;

                            #region UpdateGeneratedDictionaryItemsKres

                            if (lCurEnvironmentExists)
                            {
                                SetSelectedNodeAttributeValues(lGeneratedDictionaryItemsKresFile, iDictionaryItemBaseValue, currentEnvironmentDictionaryItemValueNode);
                            }
                            else
                            {
                                AddNewItemValueNode(lGeneratedDictionaryItemsKresFile, currentDictionaryItemNode, iDictionaryItemBaseValue);
                            }

                            if (iDictionaryItemBaseValue.EnvironmentName == "Default" && iDictionaryItemBase.UpdateAll) /*Ezert kellett orderelni es a default elso legyen*/
                            {
                                UpdateAllItemValueNodeByDefault(lGeneratedDictionaryItemsKresFile, currentDictionaryItemNode, iDictionaryItemBaseValue);
                            }


                            #endregion UpdateGeneratedDictionaryItemsKres
                        }

                        if (iDictionaryItemBase.DeleteAfterMerge || iDictionaryItemBase.IsDelete)
                        {
                            DeleteSelectedNode(lGeneratedDictionaryItemsKresFile, iDictionaryItemBase);
                        }
                    }

                    if (string.IsNullOrWhiteSpace(pTanevNev) == false)
                    {
                        lDictionaryItemUpdateScripts = GenerateUpdateScriptByCurDictionaryItemBase(lDictionaryItemUpdateScripts, iDictionaryItemBase);
                        if (iDictionaryItemBase.MergeId != null || iDictionaryItemBase.IsDelete)
                        {
                            lDictionaryItemUpdateScripts = GenerateMergeScriptByCurDictionaryItemBase(lDictionaryItemUpdateScripts, iDictionaryItemBase);
                        }
                    }
                }
                else
                {
                    lMaxDictionaryItemID++;
                    NewDictionaryIds += lMaxDictionaryItemID + ", ";
                    iDictionaryItemBase.ID = lMaxDictionaryItemID;

                    string dictionaryType = iDictionaryItemBase.Values.First(x => x.EnvironmentName == "Default").DictionaryType;
                    string dictionaryName = iDictionaryItemBase.Values.First(x => x.EnvironmentName == "Default").Name;
                    XmlNode currentDictionaryItemNode = lGeneratedDictionaryItemsKresFile.DocumentElement.SelectSingleNode("Dictionary[@Code='" + dictionaryType + "']");
                    //Insert GeneratedDictionaryItemsKres
                    XmlElement newDictionaryItemElement = lGeneratedDictionaryItemsKresFile.CreateElement("Item");
                    newDictionaryItemElement.SetAttribute("Id", iDictionaryItemBase.ID.ToString());
                    newDictionaryItemElement.SetAttribute("EnumName", GetDictionaryItemValueEgyediEnumNev(dictionaryName).ToLower());

                    foreach (DictionaryItemBaseValue iDictionaryItemBaseValue in iDictionaryItemBase.Values.OrderBy(x => x.ItemValueOrder))
                    {
                        XmlElement newDictionaryValueElement = lGeneratedDictionaryItemsKresFile.CreateElement("Value");
                        newDictionaryValueElement.SetAttribute("Name", iDictionaryItemBaseValue.Name);
                        newDictionaryValueElement.SetAttribute("Name1", iDictionaryItemBaseValue.Name1);
                        newDictionaryValueElement.SetAttribute("Name2", iDictionaryItemBaseValue.Name2);
                        newDictionaryValueElement.SetAttribute("Name3", iDictionaryItemBaseValue.Name3);
                        newDictionaryValueElement.SetAttribute("Name4", iDictionaryItemBaseValue.Name4);
                        newDictionaryValueElement.SetAttribute("Environment", iDictionaryItemBaseValue.EnvironmentName);
                        newDictionaryValueElement.SetAttribute("Protected", iDictionaryItemBaseValue.Protected.HasValue && iDictionaryItemBaseValue.Protected.Value ? "true" : "false");
                        newDictionaryValueElement.SetAttribute("Order", iDictionaryItemBaseValue.Order.Value.ToString());
                        newDictionaryValueElement.SetAttribute("Code", iDictionaryItemBaseValue.Code);
                        newDictionaryValueElement.SetAttribute("Visible", iDictionaryItemBaseValue.Torolt.HasValue && iDictionaryItemBaseValue.Torolt == true ? "false" : "true");
                        newDictionaryValueElement.SetAttribute("Color", iDictionaryItemBaseValue.Color);
                        newDictionaryValueElement.SetAttribute("Value", iDictionaryItemBaseValue.Value.HasValue ? iDictionaryItemBaseValue.Value.Value.ToString() : string.Empty);
                        newDictionaryItemElement.AppendChild(newDictionaryValueElement);

                    }
                    currentDictionaryItemNode.AppendChild(newDictionaryItemElement);

                    lDictionaryItemInsertScripts = GenerateInsertScriptByCurDictionaryItemBase(lDictionaryItemInsertScripts, iDictionaryItemBase);
                }

                XmlNode currentDictionaryItemXmlNode = lGeneratedDictionaryItemsKresFile.DocumentElement.SelectSingleNode("Dictionary/Item[@Id='" + iDictionaryItemBase.ID.ToString() + "']");
                if (currentDictionaryItemXmlNode != null)
                {
                    XmlNode currentEnvironmentDictionaryItemValueXmlNode = currentDictionaryItemXmlNode.SelectSingleNode("Value[@Environment='Default']");
                    DictionaryItemBaseValue defaultDictionaryItemBaseValue = new DictionaryItemBaseValue
                    {
                        DictionaryType = currentDictionaryItemXmlNode.ParentNode.Attributes["Code"].Value.ToString(),
                        Name = currentEnvironmentDictionaryItemValueXmlNode.Attributes["Name"].Value.ToString()
                    };
                    //SpecOszlopok
                    List<SpecOszlop> specOszlops = specOszlopList.Where(x => x.Tipus.ToLower() == defaultDictionaryItemBaseValue.DictionaryType.ToLower()).ToList();
                    if (specOszlops.Any())
                    {
                        specOszlopScriptjei += "UPDATE T_" + defaultDictionaryItemBaseValue.DictionaryType.ToUpper() + " SET" + Environment.NewLine;
                        for (int i = 0; i < specOszlops.Count; i++)
                        {
                            if (i != 0)
                                specOszlopScriptjei += ",";
                            specOszlopScriptjei += specOszlops[i].Oszlop.ToUpper() + " = -- default érék <" + specOszlops[i].DefaultErtek + ">" + Environment.NewLine;
                        }
                        specOszlopScriptjei += "WHERE ID = " + iDictionaryItemBase.ID.ToString() + " -- <" + defaultDictionaryItemBaseValue.Name + ">" + Environment.NewLine + Environment.NewLine;
                    }

                    //SpecTablak
                    List<SpecTabla> specTablas = specTablaList.Where(x => x.Tipus.ToLower() == defaultDictionaryItemBaseValue.DictionaryType.ToLower()).ToList();
                    if (specTablas.Any())
                    {
                        for (int i = 0; i < specTablas.Count; i++)
                        {
                            specTablakScriptjei += isUpdateDictionaryItemBase ?
                                specTablas[i].UpdateScript.Replace("<dictid>", iDictionaryItemBase.ID.ToString()).Replace("<dictname>", defaultDictionaryItemBaseValue.Name) + Environment.NewLine :
                                specTablas[i].InsertScript.Replace("<dictid>", iDictionaryItemBase.ID.ToString()).Replace("<dictname>", defaultDictionaryItemBaseValue.Name) + Environment.NewLine;
                        }
                    }
                }
            }

            lGeneratedDictionaryItemsKresFile.Save(GeneratedDictionaryItems_KRES);
            Thread.Sleep(100);
            SetControlsAndMsg(notExistIds, NewDictionaryIds);

            lDictionaryItemInsertScripts += ";" + Environment.NewLine + " DISABLE TRIGGER ALL ON T_DICTIONARYITEMBASE;  " +
                Environment.NewLine + @" EXEC [dev].[uspCreateDictionaryItems] NULL, NULL; " +
                Environment.NewLine + " ENABLE TRIGGER ALL ON T_DICTIONARYITEMBASE;  " +
                Environment.NewLine + " EXEC [dev].uspSwitchDictionaryItemBaseFromTmp;  ";
            lDictionaryItemUpdateScripts += ";" + Environment.NewLine + " DISABLE TRIGGER ALL ON T_DICTIONARYITEMBASE;  " +
                Environment.NewLine + @" EXEC [dev].[uspCreateDictionaryItems] NULL, NULL; " +
                Environment.NewLine + " ENABLE TRIGGER ALL ON T_DICTIONARYITEMBASE;  " +
                Environment.NewLine + " EXEC [dev].uspSwitchDictionaryItemBaseFromTmp;  ";
            lDictionaryItemUpdateScripts = lDictionaryItemUpdateScripts.Replace(",  FROM", " FROM");

            if (hasInsert)
            {
                if (!string.IsNullOrWhiteSpace(specOszlopScriptjei))
                    lDictionaryItemInsertScripts += Environment.NewLine + Environment.NewLine + specOszlopScriptjei;
                if (!string.IsNullOrWhiteSpace(specTablakScriptjei))
                    lDictionaryItemInsertScripts += Environment.NewLine + Environment.NewLine + specTablakScriptjei;
            }
            else if (hasUpdate)// csak egyik scriptes fileba generaljuk - ha van insert akkor az updatebe nem kell
            {
                if (!string.IsNullOrWhiteSpace(specOszlopScriptjei))
                    lDictionaryItemUpdateScripts += Environment.NewLine + Environment.NewLine + specOszlopScriptjei;
                if (!string.IsNullOrWhiteSpace(specTablakScriptjei))
                    lDictionaryItemUpdateScripts += Environment.NewLine + Environment.NewLine + specTablakScriptjei;
            }

            dictionaryItemInsertScripts = lDictionaryItemInsertScripts;
            return lDictionaryItemUpdateScripts;
        }

        private static void AddNewItemValueNode(XmlDocument lGeneratedDictionaryItemsKresFile, XmlNode pDictionaryItemNode, DictionaryItemBaseValue iDictionaryItemBaseValue)
        {
            XmlNode currentDictionaryItemValueDefaultNode = pDictionaryItemNode.SelectSingleNode("Value[@Environment='Default']");
            XmlElement newDictionaryValue = lGeneratedDictionaryItemsKresFile.CreateElement("Value");
            newDictionaryValue.SetAttribute("Environment", iDictionaryItemBaseValue.EnvironmentName);
            newDictionaryValue.SetAttribute("Protected", iDictionaryItemBaseValue.Protected.HasValue ? iDictionaryItemBaseValue.Protected.Value ? "true" : "false" : currentDictionaryItemValueDefaultNode.Attributes["Protected"] != null ? currentDictionaryItemValueDefaultNode.Attributes["Protected"].Value : "true");
            newDictionaryValue.SetAttribute("Order", iDictionaryItemBaseValue.Order.HasValue ? iDictionaryItemBaseValue.Order.Value.ToString() : currentDictionaryItemValueDefaultNode.Attributes["Order"] != null ? currentDictionaryItemValueDefaultNode.Attributes["Order"].Value : string.Empty);
            newDictionaryValue.SetAttribute("Visible", iDictionaryItemBaseValue.Torolt.HasValue ? iDictionaryItemBaseValue.Torolt == true ? "false" : "true" : currentDictionaryItemValueDefaultNode.Attributes["Visible"] != null ? currentDictionaryItemValueDefaultNode.Attributes["Visible"].Value : "false");
            newDictionaryValue.SetAttribute("Code", !string.IsNullOrEmpty(iDictionaryItemBaseValue.Code) ? iDictionaryItemBaseValue.Code : currentDictionaryItemValueDefaultNode.Attributes["Code"] != null ? currentDictionaryItemValueDefaultNode.Attributes["Code"].Value : string.Empty);
            newDictionaryValue.SetAttribute("Value", iDictionaryItemBaseValue.Value.HasValue ? iDictionaryItemBaseValue.Value.Value.ToString() : currentDictionaryItemValueDefaultNode.Attributes["Value"] != null ? currentDictionaryItemValueDefaultNode.Attributes["Value"].Value : string.Empty);
            newDictionaryValue.SetAttribute("Color", !string.IsNullOrEmpty(iDictionaryItemBaseValue.Color) ? iDictionaryItemBaseValue.Color : currentDictionaryItemValueDefaultNode.Attributes["Color"] != null ? currentDictionaryItemValueDefaultNode.Attributes["Color"].Value : string.Empty);
            newDictionaryValue.SetAttribute("Name", !string.IsNullOrEmpty(iDictionaryItemBaseValue.Name) ? iDictionaryItemBaseValue.Name : currentDictionaryItemValueDefaultNode.Attributes["Name"] != null ? currentDictionaryItemValueDefaultNode.Attributes["Name"].Value : string.Empty);
            newDictionaryValue.SetAttribute("Name1", !string.IsNullOrEmpty(iDictionaryItemBaseValue.Name1) ? iDictionaryItemBaseValue.Name1 : currentDictionaryItemValueDefaultNode.Attributes["Name1"] != null ? currentDictionaryItemValueDefaultNode.Attributes["Name1"].Value : string.Empty);
            newDictionaryValue.SetAttribute("Name2", !string.IsNullOrEmpty(iDictionaryItemBaseValue.Name2) ? iDictionaryItemBaseValue.Name2 : currentDictionaryItemValueDefaultNode.Attributes["Name2"] != null ? currentDictionaryItemValueDefaultNode.Attributes["Name2"].Value : string.Empty);
            newDictionaryValue.SetAttribute("Name3", !string.IsNullOrEmpty(iDictionaryItemBaseValue.Name3) ? iDictionaryItemBaseValue.Name3 : currentDictionaryItemValueDefaultNode.Attributes["Name3"] != null ? currentDictionaryItemValueDefaultNode.Attributes["Name3"].Value : string.Empty);
            newDictionaryValue.SetAttribute("Name4", !string.IsNullOrEmpty(iDictionaryItemBaseValue.Name4) ? iDictionaryItemBaseValue.Name4 : currentDictionaryItemValueDefaultNode.Attributes["Name4"] != null ? currentDictionaryItemValueDefaultNode.Attributes["Name4"].Value : string.Empty);
            pDictionaryItemNode.AppendChild(newDictionaryValue);
        }

        private static void SetSelectedNodeAttributeValues(XmlDocument lGeneratedDictionaryItemsKresFile, DictionaryItemBaseValue iDictionaryItemBaseValue, XmlNode currentEnvironmentDictionaryItemValueNode)
        {
            if (!Equal2DictionaryItemBaseValue(currentEnvironmentDictionaryItemValueNode, iDictionaryItemBaseValue)) // ha nincs kulonbseg akkor nem kell updatelni
            {
                if (iDictionaryItemBaseValue.Protected.HasValue)
                {
                    if (currentEnvironmentDictionaryItemValueNode.Attributes["Protected"] != null)
                    {
                        currentEnvironmentDictionaryItemValueNode.Attributes["Protected"].Value = iDictionaryItemBaseValue.Protected.Value ? "true" : "false";
                    }
                    else
                    {
                        XmlAttribute attr = lGeneratedDictionaryItemsKresFile.CreateAttribute("Protected");
                        attr.Value = iDictionaryItemBaseValue.Protected.Value ? "true" : "false";
                        currentEnvironmentDictionaryItemValueNode.Attributes.Append(attr);
                    }
                }
                if (iDictionaryItemBaseValue.Order.HasValue)
                {
                    if (currentEnvironmentDictionaryItemValueNode.Attributes["Order"] != null)
                    {
                        currentEnvironmentDictionaryItemValueNode.Attributes["Order"].Value = iDictionaryItemBaseValue.Order.Value.ToString();
                    }
                    else
                    {
                        XmlAttribute attr = lGeneratedDictionaryItemsKresFile.CreateAttribute("Order");
                        attr.Value = iDictionaryItemBaseValue.Order.Value.ToString();
                        currentEnvironmentDictionaryItemValueNode.Attributes.Append(attr);
                    }
                }
                if (iDictionaryItemBaseValue.Torolt.HasValue)
                {
                    if (currentEnvironmentDictionaryItemValueNode.Attributes["Visible"] == null)
                    {
                        XmlAttribute attr = lGeneratedDictionaryItemsKresFile.CreateAttribute("Visible");
                        attr.Value = (!iDictionaryItemBaseValue.Torolt.Value).ToString();
                        currentEnvironmentDictionaryItemValueNode.Attributes.Append(attr);
                    }
                    else
                    {
                        currentEnvironmentDictionaryItemValueNode.Attributes["Visible"].Value = (!iDictionaryItemBaseValue.Torolt.Value).ToString();
                    }
                }
                if (!string.IsNullOrEmpty(iDictionaryItemBaseValue.Code))
                {
                    if (currentEnvironmentDictionaryItemValueNode.Attributes["Code"] == null)
                    {
                        XmlAttribute attr = lGeneratedDictionaryItemsKresFile.CreateAttribute("Code");
                        attr.Value = iDictionaryItemBaseValue.Code;
                        currentEnvironmentDictionaryItemValueNode.Attributes.Append(attr);
                    }
                    else
                    {
                        currentEnvironmentDictionaryItemValueNode.Attributes["Code"].Value = iDictionaryItemBaseValue.Code;
                    }
                }
                if (iDictionaryItemBaseValue.Value.HasValue)
                {
                    if (currentEnvironmentDictionaryItemValueNode.Attributes["Value"] == null)
                    {
                        XmlAttribute attr = lGeneratedDictionaryItemsKresFile.CreateAttribute("Value");
                        attr.Value = iDictionaryItemBaseValue.Value.Value.ToString();
                        currentEnvironmentDictionaryItemValueNode.Attributes.Append(attr);
                    }
                    else
                    {
                        currentEnvironmentDictionaryItemValueNode.Attributes["Value"].Value = iDictionaryItemBaseValue.Value.ToString();
                    }
                }
                if (!string.IsNullOrEmpty(iDictionaryItemBaseValue.Color))
                {
                    if (currentEnvironmentDictionaryItemValueNode.Attributes["Color"] == null)
                    {
                        XmlAttribute attr = lGeneratedDictionaryItemsKresFile.CreateAttribute("Color");
                        attr.Value = iDictionaryItemBaseValue.Color;
                        currentEnvironmentDictionaryItemValueNode.Attributes.Append(attr);
                    }
                    else
                    {
                        currentEnvironmentDictionaryItemValueNode.Attributes["Color"].Value = iDictionaryItemBaseValue.Color;
                    }
                }
                if (!string.IsNullOrWhiteSpace(iDictionaryItemBaseValue.Name))
                {
                    if (currentEnvironmentDictionaryItemValueNode.Attributes["Name"] != null)
                    {
                        currentEnvironmentDictionaryItemValueNode.Attributes["Name"].Value = iDictionaryItemBaseValue.Name;
                    }
                    else
                    {
                        XmlAttribute attr = lGeneratedDictionaryItemsKresFile.CreateAttribute("Name");
                        attr.Value = iDictionaryItemBaseValue.Name;
                        currentEnvironmentDictionaryItemValueNode.Attributes.Append(attr);
                    }
                }
                if (!string.IsNullOrWhiteSpace(iDictionaryItemBaseValue.Name1))
                {
                    if (currentEnvironmentDictionaryItemValueNode.Attributes["Name1"] != null)
                    {
                        currentEnvironmentDictionaryItemValueNode.Attributes["Name1"].Value = iDictionaryItemBaseValue.Name1;
                    }
                    else
                    {
                        XmlAttribute attr = lGeneratedDictionaryItemsKresFile.CreateAttribute("Name1");
                        attr.Value = iDictionaryItemBaseValue.Name1;
                        currentEnvironmentDictionaryItemValueNode.Attributes.Append(attr);
                    }
                }
                if (!string.IsNullOrWhiteSpace(iDictionaryItemBaseValue.Name2))
                {
                    if (currentEnvironmentDictionaryItemValueNode.Attributes["Name2"] != null)
                    {
                        currentEnvironmentDictionaryItemValueNode.Attributes["Name2"].Value = iDictionaryItemBaseValue.Name2;
                    }
                    else
                    {
                        XmlAttribute attr = lGeneratedDictionaryItemsKresFile.CreateAttribute("Name2");
                        attr.Value = iDictionaryItemBaseValue.Name2;
                        currentEnvironmentDictionaryItemValueNode.Attributes.Append(attr);
                    }
                }
                if (!string.IsNullOrWhiteSpace(iDictionaryItemBaseValue.Name3))
                {
                    if (currentEnvironmentDictionaryItemValueNode.Attributes["Name3"] != null)
                    {
                        currentEnvironmentDictionaryItemValueNode.Attributes["Name3"].Value = iDictionaryItemBaseValue.Name3;
                    }
                    else
                    {
                        XmlAttribute attr = lGeneratedDictionaryItemsKresFile.CreateAttribute("Name3");
                        attr.Value = iDictionaryItemBaseValue.Name3;
                        currentEnvironmentDictionaryItemValueNode.Attributes.Append(attr);
                    }
                }
                if (!string.IsNullOrWhiteSpace(iDictionaryItemBaseValue.Name4))
                {
                    if (currentEnvironmentDictionaryItemValueNode.Attributes["Name4"] != null)
                    {
                        currentEnvironmentDictionaryItemValueNode.Attributes["Name4"].Value = iDictionaryItemBaseValue.Name4;
                    }
                    else
                    {
                        XmlAttribute attr = lGeneratedDictionaryItemsKresFile.CreateAttribute("Name4");
                        attr.Value = iDictionaryItemBaseValue.Name4;
                        currentEnvironmentDictionaryItemValueNode.Attributes.Append(attr);
                    }
                }
            }
        }

        private static void DeleteSelectedNode(XmlDocument lGeneratedDictionaryItemsKresFile, DictionaryItemBase iDictionaryItemBaseValue)
        {
            lGeneratedDictionaryItemsKresFile.DocumentElement.SelectSingleNode("Dictionary[@Code='" + iDictionaryItemBaseValue.Values[0].DictionaryType + "']").RemoveChild(
                lGeneratedDictionaryItemsKresFile.DocumentElement.SelectSingleNode("Dictionary/Item[@Id='" + iDictionaryItemBaseValue.ID.ToString() + "']"));
        }

        private static void UpdateAllItemValueNodeByDefault(XmlDocument lGeneratedDictionaryItemsKresFile, XmlNode pDictionaryItemNode, DictionaryItemBaseValue iDictionaryItemBaseValue)
        {
            XmlNode currentDictionaryItemValueDefaultNode = pDictionaryItemNode.SelectSingleNode("Value[@Environment='Default']");
            foreach (XmlNode item in pDictionaryItemNode.SelectNodes("Value"))
            {
                if (item.Attributes["Environment"].Value != "Default")
                {
                    item.Attributes["Protected"].Value = !iDictionaryItemBaseValue.Protected.HasValue ? item.Attributes["Protected"].Value : currentDictionaryItemValueDefaultNode.Attributes["Protected"] == null ? string.Empty : currentDictionaryItemValueDefaultNode.Attributes["Protected"].Value;
                    item.Attributes["Order"].Value = !iDictionaryItemBaseValue.Order.HasValue ? item.Attributes["Order"].Value : currentDictionaryItemValueDefaultNode.Attributes["Order"] == null ? string.Empty : currentDictionaryItemValueDefaultNode.Attributes["Order"].Value;
                    item.Attributes["Visible"].Value = !iDictionaryItemBaseValue.Torolt.HasValue ? item.Attributes["Visible"].Value : currentDictionaryItemValueDefaultNode.Attributes["Visible"] == null ? string.Empty : currentDictionaryItemValueDefaultNode.Attributes["Visible"].Value;
                    item.Attributes["Code"].Value = string.IsNullOrWhiteSpace(iDictionaryItemBaseValue.Code) ? item.Attributes["Code"].Value : currentDictionaryItemValueDefaultNode.Attributes["Code"] == null ? string.Empty : currentDictionaryItemValueDefaultNode.Attributes["Code"].Value;
                    item.Attributes["Value"].Value = !iDictionaryItemBaseValue.Value.HasValue ? item.Attributes["Value"].Value : currentDictionaryItemValueDefaultNode.Attributes["Value"] == null ? string.Empty : currentDictionaryItemValueDefaultNode.Attributes["Value"].Value;
                    item.Attributes["Color"].Value = string.IsNullOrWhiteSpace(iDictionaryItemBaseValue.Color) ? item.Attributes["Color"].Value : currentDictionaryItemValueDefaultNode.Attributes["Color"] == null ? string.Empty : currentDictionaryItemValueDefaultNode.Attributes["Color"].Value;
                    item.Attributes["Name"].Value = string.IsNullOrWhiteSpace(iDictionaryItemBaseValue.Name) ? item.Attributes["Name"].Value : currentDictionaryItemValueDefaultNode.Attributes["Name"] == null ? string.Empty : currentDictionaryItemValueDefaultNode.Attributes["Name"].Value;
                    item.Attributes["Name1"].Value = string.IsNullOrWhiteSpace(iDictionaryItemBaseValue.Name1) ? item.Attributes["Name1"].Value : currentDictionaryItemValueDefaultNode.Attributes["Name1"] == null ? string.Empty : currentDictionaryItemValueDefaultNode.Attributes["Name1"].Value;
                    item.Attributes["Name2"].Value = string.IsNullOrWhiteSpace(iDictionaryItemBaseValue.Name2) ? item.Attributes["Name2"].Value : currentDictionaryItemValueDefaultNode.Attributes["Name2"] == null ? string.Empty : currentDictionaryItemValueDefaultNode.Attributes["Name2"].Value;
                    item.Attributes["Name3"].Value = string.IsNullOrWhiteSpace(iDictionaryItemBaseValue.Name3) ? item.Attributes["Name3"].Value : currentDictionaryItemValueDefaultNode.Attributes["Name3"] == null ? string.Empty : currentDictionaryItemValueDefaultNode.Attributes["Name3"].Value;
                    item.Attributes["Name4"].Value = string.IsNullOrWhiteSpace(iDictionaryItemBaseValue.Name4) ? item.Attributes["Name4"].Value : currentDictionaryItemValueDefaultNode.Attributes["Name4"] == null ? string.Empty : currentDictionaryItemValueDefaultNode.Attributes["Name4"].Value;
                }
            }
        }

        private static bool Equal2DictionaryItemBaseValue(XmlNode iDictionaryValue, DictionaryItemBaseValue pDictionaryItemBaseValue)
        {
            DictionaryItemBaseValue lDictionaryItemBaseValue = new DictionaryItemBaseValue();
            lDictionaryItemBaseValue.DictionaryType = pDictionaryItemBaseValue.DictionaryType;
            lDictionaryItemBaseValue.DictionaryTypeId = pDictionaryItemBaseValue.DictionaryTypeId;
            lDictionaryItemBaseValue.EnvironmentName = iDictionaryValue.Attributes["Environment"].Value;
            if (iDictionaryValue.Attributes["Name"] != null &&
                !string.IsNullOrEmpty(iDictionaryValue.Attributes["Name"].Value))
            {
                lDictionaryItemBaseValue.Name = iDictionaryValue.Attributes["Name"].Value;
            }
            if (iDictionaryValue.Attributes["Name1"] != null &&
                !string.IsNullOrEmpty(iDictionaryValue.Attributes["Name1"].Value))
            {
                lDictionaryItemBaseValue.Name1 = iDictionaryValue.Attributes["Name1"].Value;
            }
            if (iDictionaryValue.Attributes["Name2"] != null &&
                !string.IsNullOrEmpty(iDictionaryValue.Attributes["Name2"].Value))
            {
                lDictionaryItemBaseValue.Name2 = iDictionaryValue.Attributes["Name2"].Value;
            }
            if (iDictionaryValue.Attributes["Name3"] != null &&
                !string.IsNullOrEmpty(iDictionaryValue.Attributes["Name3"].Value))
            {
                lDictionaryItemBaseValue.Name3 = iDictionaryValue.Attributes["Name3"].Value;
            }
            if (iDictionaryValue.Attributes["Name4"] != null &&
                !string.IsNullOrEmpty(iDictionaryValue.Attributes["Name4"].Value))
            {
                lDictionaryItemBaseValue.Name4 = iDictionaryValue.Attributes["Name4"].Value;
            }
            if (iDictionaryValue.Attributes["Protected"] != null &&
                !string.IsNullOrEmpty(iDictionaryValue.Attributes["Protected"].Value))
            {
                bool Protected;
                Boolean.TryParse(iDictionaryValue.Attributes["Protected"].Value, out Protected);
                lDictionaryItemBaseValue.Protected = pDictionaryItemBaseValue.Protected.HasValue ? Protected : pDictionaryItemBaseValue.Protected;
            }
            if (iDictionaryValue.Attributes["Order"] != null &&
                !string.IsNullOrEmpty(iDictionaryValue.Attributes["Order"].Value))
            {
                int Order;
                Int32.TryParse(iDictionaryValue.Attributes["Order"].Value, out Order);
                lDictionaryItemBaseValue.Order = pDictionaryItemBaseValue.Order.HasValue ? Order : pDictionaryItemBaseValue.Order;
            }
            if (iDictionaryValue.Attributes["Visible"] != null &&
                !string.IsNullOrEmpty(iDictionaryValue.Attributes["Visible"].Value))
            {
                bool Visible;
                Boolean.TryParse(iDictionaryValue.Attributes["Visible"].Value, out Visible);
                lDictionaryItemBaseValue.Torolt = pDictionaryItemBaseValue.Torolt.HasValue ? !Visible : pDictionaryItemBaseValue.Torolt;
            }
            if (iDictionaryValue.Attributes["Code"] != null &&
                !string.IsNullOrEmpty(iDictionaryValue.Attributes["Code"].Value))
            {
                lDictionaryItemBaseValue.Code = iDictionaryValue.Attributes["Code"].Value;
            }
            if (iDictionaryValue.Attributes["Value"] != null &&
                !string.IsNullOrEmpty(iDictionaryValue.Attributes["Value"].Value))
            {
                int Value;
                Int32.TryParse(iDictionaryValue.Attributes["Value"].Value, out Value);
                lDictionaryItemBaseValue.Value = Value;
            }
            if (iDictionaryValue.Attributes["Color"] != null &&
                !string.IsNullOrEmpty(iDictionaryValue.Attributes["Color"].Value))
            {
                lDictionaryItemBaseValue.Color = iDictionaryValue.Attributes["Color"].Value;
            }
            return lDictionaryItemBaseValue.Equals(pDictionaryItemBaseValue);
        }

        private string GenerateUpdateScriptByCurDictionaryItemBase(string lDictionaryItemUpdateScripts, DictionaryItemBase iDictionaryItemBase)
        {
            lDictionaryItemUpdateScripts = SetUpdateScriptByEnviromentName(lDictionaryItemUpdateScripts, iDictionaryItemBase, "KK");
            lDictionaryItemUpdateScripts = SetUpdateScriptByEnviromentName(lDictionaryItemUpdateScripts, iDictionaryItemBase, "NSZFH");
            lDictionaryItemUpdateScripts = SetUpdateScriptByEnviromentName(lDictionaryItemUpdateScripts, iDictionaryItemBase, "HOI");
            lDictionaryItemUpdateScripts = SetUpdateScriptByEnviromentName(lDictionaryItemUpdateScripts, iDictionaryItemBase, "AZURE");

            return lDictionaryItemUpdateScripts;
        }

        private static string SetUpdateScriptByEnviromentName(string pDictionaryItemUpdateScripts, DictionaryItemBase pDictionaryItemBase, string pEnvironmentName)
        {
            hasUpdate = true;
            pDictionaryItemUpdateScripts += " IF @TEMP_EnvironmentName = '" + pEnvironmentName + "'" + Environment.NewLine + "  BEGIN ";
            DictionaryItemBaseValue dictionaryItemBaseValue = new DictionaryItemBaseValue();
            if (pDictionaryItemBase.Values.Any(x => x.EnvironmentName == pEnvironmentName))
            {
                dictionaryItemBaseValue = pDictionaryItemBase.Values.First(x => x.EnvironmentName == pEnvironmentName);
            }
            else if (pDictionaryItemBase.Values.Any(x => x.EnvironmentName == "Default"))
            {
                dictionaryItemBaseValue = pDictionaryItemBase.Values.First(x => x.EnvironmentName == "Default");
            }

            pDictionaryItemUpdateScripts += Environment.NewLine +
                "  INSERT INTO tmpForSwitchDictionaryItemBase(RegiID, UjID, TanevID, C_NAME, C_TYPE, Torolni) " + Environment.NewLine +
                "  SELECT DIB.ID, " + pDictionaryItemBase.ID.ToString() + @", DIB.C_TANEVID, DIB.C_NAME, DIB.C_TYPE, '" + (pDictionaryItemBase.IsDelete || pDictionaryItemBase.DeleteAfterMerge ? "T" : "F") + "' " + Environment.NewLine +
                "  FROM T_DICTIONARYITEMBASE DIB INNER JOIN T_TANEV t ON t.ID = DIB.C_TANEVID AND t.TOROLT = 'F' AND t.C_SORSZAM >= @TanevSorszam AND t.C_SORSZAM <= @LastTanevSorszam " + Environment.NewLine +
                "    WHERE DIB.C_DICTIONARYTYPEID = " + dictionaryItemBaseValue.DictionaryTypeId + @" AND DIB.C_NAME = N'" + dictionaryItemBaseValue.Name + @"' AND DIB.TOROLT = 'F' " + Environment.NewLine +
                "  UPDATE DIB SET " + Environment.NewLine +
                "    DIB.TOROLT = 'T' " + Environment.NewLine +
                "  FROM T_DICTIONARYITEMBASE DIB INNER JOIN T_TANEV t ON t.ID = DIB.C_TANEVID AND t.TOROLT = 'F' AND t.C_SORSZAM >= @TanevSorszam AND t.C_SORSZAM <= @LastTanevSorszam " + Environment.NewLine +
                "    WHERE DIB.C_DICTIONARYTYPEID = " + dictionaryItemBaseValue.DictionaryTypeId + @" AND DIB.C_NAME = N'" + dictionaryItemBaseValue.Name + @"' AND DIB.TOROLT = 'F' " + Environment.NewLine +
                "  UPDATE DIB SET DIB.TOROLT = 'F' " +
            (string.IsNullOrWhiteSpace(dictionaryItemBaseValue.Name) ? "" : @"    ,DIB.C_NAME = N'" + dictionaryItemBaseValue.Name + "' " + Environment.NewLine) +
            (string.IsNullOrWhiteSpace(dictionaryItemBaseValue.Name1) ? "" : @"    ,DIB.C_NAME_1 = N'" + dictionaryItemBaseValue.Name1 + "' " + Environment.NewLine) +
            (string.IsNullOrWhiteSpace(dictionaryItemBaseValue.Name2) ? "" : @"    ,DIB.C_NAME_2 = N'" + dictionaryItemBaseValue.Name2 + "' " + Environment.NewLine) +
            (string.IsNullOrWhiteSpace(dictionaryItemBaseValue.Name3) ? "" : @"    ,DIB.C_NAME_3 = N'" + dictionaryItemBaseValue.Name3 + "' " + Environment.NewLine) +
            (string.IsNullOrWhiteSpace(dictionaryItemBaseValue.Name4) ? "" : @"    ,DIB.C_NAME_4 = N'" + dictionaryItemBaseValue.Name4 + "' " + Environment.NewLine) +
            (string.IsNullOrWhiteSpace(dictionaryItemBaseValue.Code) ? "" : @"    ,DIB.C_CODE = N'" + dictionaryItemBaseValue.Code + "' " + Environment.NewLine) +
            (string.IsNullOrWhiteSpace(dictionaryItemBaseValue.Color) ? "" : @"    ,DIB.C_COLOR = N'" + dictionaryItemBaseValue.Color + "' " + Environment.NewLine) +
            (dictionaryItemBaseValue.Protected.HasValue == false ? "" : @"    ,DIB.C_PROTECTED = N'" + (dictionaryItemBaseValue.Protected.Value ? "T" : "F") + "' " + Environment.NewLine) +
            (dictionaryItemBaseValue.Torolt.HasValue == false ? "" : @"    ,DIB.C_VISIBLE = N'" + (dictionaryItemBaseValue.Torolt.Value ? "F" : "T") + "' " + Environment.NewLine) +
            (dictionaryItemBaseValue.Order.HasValue == false ? "" : @"    ,DIB.C_ORDER = " + dictionaryItemBaseValue.Order.Value.ToString() + " " + Environment.NewLine) +
            (dictionaryItemBaseValue.Value.HasValue == false ? "" : @"    ,DIB.C_VALUE = " + dictionaryItemBaseValue.Value.Value.ToString() + " " + Environment.NewLine) +
                "  FROM T_DICTIONARYITEMBASE DIB " + Environment.NewLine +
                "  INNER JOIN T_TANEV t ON t.ID = DIB.C_TANEVID AND t.TOROLT = 'F' AND t.C_SORSZAM >= @TanevSorszam AND t.C_SORSZAM <= @LastTanevSorszam " + Environment.NewLine +
                "    WHERE DIB.ID = " + pDictionaryItemBase.ID.ToString() + ";" + Environment.NewLine +
                 "  END";

            return pDictionaryItemUpdateScripts;
        }

        private string GenerateInsertScriptByCurDictionaryItemBase(string lDictionaryItemInsertScripts, DictionaryItemBase pDictionaryItemBase)
        {
            lDictionaryItemInsertScripts = SetInsertScritByCurDictionaryItemBaseAndEnviromentName(lDictionaryItemInsertScripts, pDictionaryItemBase, "KK");
            lDictionaryItemInsertScripts = SetInsertScritByCurDictionaryItemBaseAndEnviromentName(lDictionaryItemInsertScripts, pDictionaryItemBase, "NSZFH");
            lDictionaryItemInsertScripts = SetInsertScritByCurDictionaryItemBaseAndEnviromentName(lDictionaryItemInsertScripts, pDictionaryItemBase, "HOI");
            lDictionaryItemInsertScripts = SetInsertScritByCurDictionaryItemBaseAndEnviromentName(lDictionaryItemInsertScripts, pDictionaryItemBase, "AZURE");

            return lDictionaryItemInsertScripts;
        }

        private static string SetInsertScritByCurDictionaryItemBaseAndEnviromentName(string lDictionaryItemInsertScripts, DictionaryItemBase pDictionaryItemBase, string pEnvironmentName)
        {
            hasInsert = true;
            lDictionaryItemInsertScripts += Environment.NewLine + "IF @TEMP_EnvironmentName = '" + pEnvironmentName + "'" + Environment.NewLine + "  BEGIN ";
            DictionaryItemBaseValue dictionaryItemBaseValue = new DictionaryItemBaseValue();
            if (pDictionaryItemBase.Values.Any(x => x.EnvironmentName == pEnvironmentName))
            {
                dictionaryItemBaseValue = pDictionaryItemBase.Values.First(x => x.EnvironmentName == pEnvironmentName);
            }
            else
            {
                dictionaryItemBaseValue = pDictionaryItemBase.Values.First(x => x.EnvironmentName == "Default");
            }
            lDictionaryItemInsertScripts += Environment.NewLine + "    -----  " + pDictionaryItemBase.ID.ToString() + " ----- " + dictionaryItemBaseValue.Name + @" -----" + Environment.NewLine +
                "    INSERT INTO tmpForSwitchDictionaryItemBase(RegiID, UjID, TanevID, C_NAME, C_TYPE, Torolni)" + Environment.NewLine +
                "    SELECT DIB.ID, " + pDictionaryItemBase.ID.ToString() + @", DIB.C_TANEVID, DIB.C_NAME, DIB.C_TYPE, 'F' " + Environment.NewLine +
                "    FROM T_DICTIONARYITEMBASE DIB " + Environment.NewLine +
                "      WHERE DIB.C_DICTIONARYTYPEID = " + dictionaryItemBaseValue.DictionaryTypeId + " AND DIB.C_NAME = N'" + dictionaryItemBaseValue.Name + @"' AND DIB.TOROLT = 'F' " + Environment.NewLine +
                "    UPDATE DIB SET " + Environment.NewLine +
                "    DIB.TOROLT = 'T' " + Environment.NewLine +
                "    FROM T_DICTIONARYITEMBASE DIB " + Environment.NewLine +
                "      WHERE DIB.C_DICTIONARYTYPEID = " + dictionaryItemBaseValue.DictionaryTypeId + " AND DIB.C_NAME = N'" + dictionaryItemBaseValue.Name + @"' AND DIB.TOROLT = 'F' " + Environment.NewLine + "END " + Environment.NewLine;
            return lDictionaryItemInsertScripts;
        }

        private string GenerateMergeScriptByCurDictionaryItemBase(string lDictionaryItemInsertScripts, DictionaryItemBase pDictionaryItemBase)
        {
            lDictionaryItemInsertScripts = SetMergeScriptByCurDictionaryItemBaseAndEnviromentName(lDictionaryItemInsertScripts, pDictionaryItemBase, "KK");
            lDictionaryItemInsertScripts = SetMergeScriptByCurDictionaryItemBaseAndEnviromentName(lDictionaryItemInsertScripts, pDictionaryItemBase, "NSZFH");
            lDictionaryItemInsertScripts = SetMergeScriptByCurDictionaryItemBaseAndEnviromentName(lDictionaryItemInsertScripts, pDictionaryItemBase, "HOI");
            lDictionaryItemInsertScripts = SetMergeScriptByCurDictionaryItemBaseAndEnviromentName(lDictionaryItemInsertScripts, pDictionaryItemBase, "AZURE");

            return lDictionaryItemInsertScripts;
        }

        private static string SetMergeScriptByCurDictionaryItemBaseAndEnviromentName(string lDictionaryItemMergeScripts, DictionaryItemBase pDictionaryItemBase, string pEnvironmentName)
        {
            lDictionaryItemMergeScripts += Environment.NewLine + "IF @TEMP_EnvironmentName = '" + pEnvironmentName + "'" + Environment.NewLine + "BEGIN" + Environment.NewLine;
            DictionaryItemBaseValue dictionaryItemBaseValue = new DictionaryItemBaseValue();
            if (pDictionaryItemBase.Values.Any(x => x.EnvironmentName == pEnvironmentName))
            {
                dictionaryItemBaseValue = pDictionaryItemBase.Values.First(x => x.EnvironmentName == pEnvironmentName);
            }
            else if (pDictionaryItemBase.Values.Any(x => x.EnvironmentName == "Default"))
            {
                dictionaryItemBaseValue = pDictionaryItemBase.Values.First(x => x.EnvironmentName == "Default");
            }

            lDictionaryItemMergeScripts += Environment.NewLine + "    -----  " + pDictionaryItemBase.ID.ToString() + " ----- " + dictionaryItemBaseValue.Name + @" -----" + Environment.NewLine +
                "    INSERT INTO tmpForSwitchDictionaryItemBase(RegiID, UjID, TanevID, C_NAME, C_TYPE, Torolni) " + Environment.NewLine +
                "    SELECT " + pDictionaryItemBase.ID.ToString() + ", " + (pDictionaryItemBase.MergeId.HasValue ? pDictionaryItemBase.MergeId.ToString() : "NULL") + @", DIB.C_TANEVID, DIB.C_NAME, DIB.C_TYPE, '" + (pDictionaryItemBase.IsDelete || pDictionaryItemBase.DeleteAfterMerge ? "T" : "F") + "' " + Environment.NewLine +
                "    FROM T_DICTIONARYITEMBASE DIB " + Environment.NewLine +
                "      WHERE DIB.C_DICTIONARYTYPEID = " + dictionaryItemBaseValue.DictionaryTypeId + " AND DIB.ID = " + pDictionaryItemBase.ID.ToString() + @" AND DIB.TOROLT = 'F' " + Environment.NewLine +
                "    UPDATE DIB SET " + Environment.NewLine +
                "    DIB.C_VISIBLE = '" + ((dictionaryItemBaseValue.Torolt.HasValue && dictionaryItemBaseValue.Torolt.Value) ? "F" : "T") + @"' " + Environment.NewLine +
                "    FROM T_DICTIONARYITEMBASE DIB " + Environment.NewLine +
                "      WHERE DIB.C_DICTIONARYTYPEID = " + dictionaryItemBaseValue.DictionaryTypeId + " AND DIB.ID = " + pDictionaryItemBase.ID.ToString() + @" AND DIB.TOROLT = 'F' " + Environment.NewLine;

            if (pDictionaryItemBase.DeleteAfterMerge || pDictionaryItemBase.IsDelete)
            {
                lDictionaryItemMergeScripts +=
                "    UPDATE dibspec SET dibspec.TOROLT = 'T' FROM T_" + dictionaryItemBaseValue.DictionaryType + " dibspec INNER JOIN T_TANEV t ON t.ID = dibspec.C_ALTANEVID AND t.TOROLT = 'F' AND t.C_SORSZAM >= @TanevSorszam AND t.C_SORSZAM <= @LastTanevSorszam " + Environment.NewLine +
                "    WHERE dibspec.ID = " + pDictionaryItemBase.ID.ToString() + " AND dibspec.TOROLT = 'F' " + Environment.NewLine + Environment.NewLine +
                "    UPDATE dib SET dib.TOROLT = 'T' FROM T_DICTIONARYITEMBASE dib " + Environment.NewLine +
                "    WHERE dib.ID = " + pDictionaryItemBase.ID.ToString() + " AND dib.TOROLT = 'F' " + Environment.NewLine;
            }
            lDictionaryItemMergeScripts += "  END" + Environment.NewLine;
            return lDictionaryItemMergeScripts;
        }

        private string GetMigtrationFileContent(string pCurDateTime, string pTaskNumber, string DictionaryItemBaseUpdateMigration_Minta, bool pKellInsertScript, bool pKellUpdateScript)
        {
            string result = File.ReadAllText(DictionaryItemBaseUpdateMigration_Minta, encoding);
            string result1 = string.Empty;
            string result2 = string.Empty;
            if (pKellInsertScript)
            {
                result1 = result.Replace("TASKNUMBER_INSERT", pTaskNumber + "_InsertScripts");
            }
            else
            {
                result1 = result.Replace("ExecuteScripts(\"TASKNUMBER_INSERT.sql\");", "");
            }

            if (pKellUpdateScript)
            {
                result2 = result1.Replace("TASKNUMBER_UPDATE", pTaskNumber + "_UpdateScripts").Replace("CURDATETIME", pCurDateTime).Replace("TASKNUMBER", pTaskNumber);
            }
            else
            {
                result2 = result1.Replace("ExecuteScripts(\"TASKNUMBER_UPDATE.sql\");", "").Replace("CURDATETIME", pCurDateTime).Replace("TASKNUMBER", pTaskNumber);
            }

            return result2;
        }

        #region UpdateFile
        private static List<DictionaryItemBase> GetDataFromExcel(ExcelWorksheet ws)
        {
            List<DictionaryItemBase> lDictionaryItemBaseList = new List<DictionaryItemBase>();
            var lastRow = ws.Dimension.End.Row;
            for (int rowIndex = 3; rowIndex <= lastRow; rowIndex++)
            {
                var columnIndex = 1;
                //NOTE: Ha a sorban bármelyik mező nem üres beolvassuk a sort
                if (ws.Cells[rowIndex, 1, rowIndex, ws.Dimension.End.Column].Any(c => !string.IsNullOrEmpty(c.Text)))
                {
                    var actualRow = new List<string>();
                    while (columnIndex <= ws.Dimension.End.Column)
                    {
                        var actualCell = GetExcelData(ws, columnIndex, rowIndex);
                        actualRow.Add(actualCell);
                        columnIndex++;
                    }
                    lDictionaryItemBaseList.Add(GetDictionaryItemBaseFromListString(actualRow, rowIndex));
                }
            }

            return lDictionaryItemBaseList;
        }

        private static void GetSpecTipusScriptsFromExcel(ExcelWorksheets wsList, out List<SpecOszlop> pSpecOszlopList, out List<SpecTabla> pSpecTablaList, out List<SpecKomment> pSpecKommentList)
        {
            #region SpecOszlop
            List<SpecOszlop> specOszlops = new List<SpecOszlop>();
            ExcelWorksheet ws1 = wsList[1];
            var lastRow1 = ws1.Dimension.End.Row;
            for (int rowIndex = 2; rowIndex <= lastRow1; rowIndex++)
            {
                var columnIndex = 1;
                //NOTE: Ha a sorban bármelyik mező nem üres beolvassuk a sort
                if (ws1.Cells[rowIndex, 1, rowIndex, ws1.Dimension.End.Column].Any(c => !string.IsNullOrEmpty(c.Text)))
                {
                    var actualRow = new List<string>();
                    while (columnIndex <= ws1.Dimension.End.Column)
                    {
                        var actualCell = GetExcelData(ws1, columnIndex, rowIndex, false);
                        actualRow.Add(actualCell);
                        columnIndex++;
                    }
                    if (!string.IsNullOrWhiteSpace(actualRow[0]) && !string.IsNullOrWhiteSpace(actualRow[1]))
                    {
                        specOszlops.Add(new SpecOszlop
                        {
                            Tipus = actualRow[0].ToString().Substring(0, 2).ToLower() == "t_" ? actualRow[0].ToString().Substring(2) : actualRow[0].ToString(),
                            Oszlop = actualRow[1],
                            DefaultErtek = actualRow[2]
                        });
                    }
                }
            }
            pSpecOszlopList = specOszlops;
            #endregion SpecOszlop

            #region SpecTabla
            List<SpecTabla> specTablas = new List<SpecTabla>();
            ExcelWorksheet ws2 = wsList[2];

            var lastRow2 = ws2.Dimension.End.Row;
            for (int rowIndex = 2; rowIndex <= lastRow2; rowIndex++)
            {
                var columnIndex = 1;
                //NOTE: Ha a sorban bármelyik mező nem üres beolvassuk a sort
                if (ws2.Cells[rowIndex, 1, rowIndex, ws2.Dimension.End.Column].Any(c => !string.IsNullOrEmpty(c.Text)))
                {
                    var actualRow = new List<string>();
                    while (columnIndex <= ws2.Dimension.End.Column)
                    {
                        var actualCell = GetExcelData(ws2, columnIndex, rowIndex, false);
                        actualRow.Add(actualCell);
                        columnIndex++;
                    }
                    if (!string.IsNullOrWhiteSpace(actualRow[0]) && !string.IsNullOrWhiteSpace(actualRow[1]))
                    {
                        specTablas.Add(new SpecTabla
                        {
                            Tipus = actualRow[0].ToString().Substring(0, 2).ToLower() == "t_" ? actualRow[0].ToString().Substring(2) : actualRow[0].ToString(),
                            InsertScript = actualRow[1],
                            UpdateScript = actualRow[2]
                        });
                    }
                }
            }
            pSpecTablaList = specTablas;
            #endregion SpecTabla

            #region SpecKomment
            List<SpecKomment> specKomments = new List<SpecKomment>();
            ExcelWorksheet ws3 = wsList[3];

            var lastRow3 = ws3.Dimension.End.Row;
            for (int rowIndex = 2; rowIndex <= lastRow3; rowIndex++)
            {
                var columnIndex = 1;
                //NOTE: Ha a sorban bármelyik mező nem üres beolvassuk a sort
                if (ws3.Cells[rowIndex, 1, rowIndex, ws3.Dimension.End.Column].Any(c => !string.IsNullOrEmpty(c.Text)))
                {
                    var actualRow = new List<string>();
                    while (columnIndex <= ws3.Dimension.End.Column)
                    {
                        var actualCell = GetExcelData(ws3, columnIndex, rowIndex, false);
                        actualRow.Add(actualCell);
                        columnIndex++;
                    }
                    if (!string.IsNullOrWhiteSpace(actualRow[0]) && !string.IsNullOrWhiteSpace(actualRow[1]))
                    {
                        specKomments.Add(new SpecKomment
                        {
                            Tipus = actualRow[0],
                            Szoveg = actualRow[1]
                        });
                    }
                }
            }
            pSpecKommentList = specKomments;
            #endregion SpecKomment
        }

        private static string GetExcelData(ExcelWorksheet workSheet, int columnIndex, int rowIndex, bool withTrim = true)
        {
            var cellValue = workSheet.Cells[rowIndex, columnIndex].Text;
            var result = withTrim ? ReplaceMultipleSpacesAndTrim(cellValue) : cellValue;
            return result;
        }

        private static DictionaryItemBase GetDictionaryItemBaseFromListString(List<string> actualRow, int rowIndex)
        {
            DictionaryItemBase lDictionaryItemBase = new DictionaryItemBase();
            lDictionaryItemBase.ID = string.IsNullOrWhiteSpace(actualRow[0]) ? (int?)null : Convert.ToInt32(CultureInfo.CurrentCulture.TextInfo.ToTitleCase(actualRow[0].ToLower()));
            lDictionaryItemBase.UpdateAll = !lDictionaryItemBase.ID.HasValue ? true : string.IsNullOrWhiteSpace(actualRow[1]) ? false : actualRow[1].ToString().ToUpper() == "T"; /*Uj itemn eseten is defultrol atmasolni ami nincs kitolve*/

            for (int i = 0; i < 5; i++)
            {
                var environmentName = string.Empty;
                switch (i)
                {
                    default:
                    case 0:
                        environmentName = "Default";
                        break;
                    case 1:
                        environmentName = "KK";
                        break;
                    case 2:
                        environmentName = "NSZFH";
                        break;
                    case 3:
                        environmentName = "HOI";
                        break;
                    case 4:
                        environmentName = "AZURE";
                        break;
                }
                int columnstartindex = (i * 10) + 1;
                if ((i == 0 && lDictionaryItemBase.UpdateAll) /*a defaultra szukseg van mindenkepp ha arrol kell updatelni*/
                    || !string.IsNullOrWhiteSpace(actualRow[columnstartindex + 1])
                    || !string.IsNullOrWhiteSpace(actualRow[columnstartindex + 2])
                    || !string.IsNullOrWhiteSpace(actualRow[columnstartindex + 3])
                    || !string.IsNullOrWhiteSpace(actualRow[columnstartindex + 4])
                    || !string.IsNullOrWhiteSpace(actualRow[columnstartindex + 5])
                    || !string.IsNullOrWhiteSpace(actualRow[columnstartindex + 6])
                    || !string.IsNullOrWhiteSpace(actualRow[columnstartindex + 7])
                    || !string.IsNullOrWhiteSpace(actualRow[columnstartindex + 8])
                    || !string.IsNullOrWhiteSpace(actualRow[columnstartindex + 9])
                    || !string.IsNullOrWhiteSpace(actualRow[columnstartindex + 10]))
                {
                    if (!string.IsNullOrEmpty(environmentName))
                    {
                        DictionaryItemBaseValue defaultDictionaryItemBaseValue = new DictionaryItemBaseValue();
                        if (i != 0 && lDictionaryItemBase.UpdateAll)/*ha nem a default es kell updatelni*/
                        {
                            defaultDictionaryItemBaseValue = lDictionaryItemBase.Values.First(x => x.EnvironmentName == "Default");
                        }
                        lDictionaryItemBase.Values.Add(new DictionaryItemBaseValue
                        {
                            EnvironmentName = environmentName,
                            Name = string.IsNullOrWhiteSpace(actualRow[columnstartindex + 1]) ? defaultDictionaryItemBaseValue.Name : actualRow[columnstartindex + 1],
                            Order = string.IsNullOrWhiteSpace(actualRow[columnstartindex + 2]) ? defaultDictionaryItemBaseValue.Order : Convert.ToInt32(CultureInfo.CurrentCulture.TextInfo.ToTitleCase(actualRow[columnstartindex + 2].ToLower())),
                            Torolt = string.IsNullOrWhiteSpace(actualRow[columnstartindex + 3]) ? defaultDictionaryItemBaseValue.Torolt : actualRow[columnstartindex + 3].ToString().ToUpper() == "T",
                            Code = string.IsNullOrWhiteSpace(actualRow[columnstartindex + 4]) ? defaultDictionaryItemBaseValue.Code : actualRow[columnstartindex + 4],
                            Protected = string.IsNullOrWhiteSpace(actualRow[columnstartindex + 5]) ? defaultDictionaryItemBaseValue.Protected : actualRow[columnstartindex + 5].ToString().ToUpper() == "T",
                            Name1 = string.IsNullOrWhiteSpace(actualRow[columnstartindex + 6]) ? defaultDictionaryItemBaseValue.Name1 : actualRow[columnstartindex + 6],
                            Name2 = string.IsNullOrWhiteSpace(actualRow[columnstartindex + 7]) ? defaultDictionaryItemBaseValue.Name2 : actualRow[columnstartindex + 7],
                            Name3 = string.IsNullOrWhiteSpace(actualRow[columnstartindex + 8]) ? defaultDictionaryItemBaseValue.Name3 : actualRow[columnstartindex + 8],
                            Name4 = string.IsNullOrWhiteSpace(actualRow[columnstartindex + 9]) ? defaultDictionaryItemBaseValue.Name4 : actualRow[columnstartindex + 9],
                            DictionaryType = string.IsNullOrWhiteSpace(actualRow[columnstartindex + 10]) ? defaultDictionaryItemBaseValue.DictionaryType : actualRow[columnstartindex + 10],
                            ItemValueOrder = i
                        });
                    }
                }
            }

            lDictionaryItemBase.MergeId = actualRow.Count > 52 && string.IsNullOrWhiteSpace(actualRow[52]) ? (int?)null : Convert.ToInt32(CultureInfo.CurrentCulture.TextInfo.ToTitleCase(actualRow[52].ToLower()));
            lDictionaryItemBase.DeleteAfterMerge = actualRow.Count > 53 && !string.IsNullOrWhiteSpace(actualRow[53]) && CultureInfo.CurrentCulture.TextInfo.ToTitleCase(actualRow[53].ToUpper()) == "T";
            lDictionaryItemBase.IsDelete = actualRow.Count > 54 && !string.IsNullOrWhiteSpace(actualRow[54]) && CultureInfo.CurrentCulture.TextInfo.ToTitleCase(actualRow[54].ToUpper()) == "T";
            return lDictionaryItemBase;
        }

        #endregion

        #region HelperMethods
        public static string ReplaceMultipleSpacesAndTrim(string text)
        {
            var result = ReplaceMultipleSpaces(text).Trim();
            return result;
        }
        public static string ReplaceMultipleSpaces(string text)
        {
            if (text == null)
            {
                return null;
            }
            var result = Regex.Replace(text, @"\s+", " ");
            return result;
        }

        public static string GetDictionaryItemValueEgyediEnumNev(string pName)
        {
            return pName
                .ToLower().Replace(" ", "_").Replace("-", "").Replace("á", "a").Replace("é", "e").Replace("í", "i").Replace("ó", "o")
                .Replace("ö", "o").Replace("ő", "o").Replace("ú", "u").Replace("ü", "u").Replace("ű", "u").Replace(",", "").Replace(".", "")
                .Replace("(", "").Replace("[", "").Replace(")", "").Replace("]", "").Replace("…", "_").Replace("/", "_").Replace("\\", "")
                .Replace("–", "").Replace("?", "").Replace("!", "").Replace(":", "").Replace("*", "_").Replace("§", "").Replace("%", "")
                .Replace("+", "").Replace("@", "").Replace("\"", "");
        }
        #endregion


    }
}
